#ifndef _GO_H_
#define _GO_H_

#include "n3dmath.h"

enum {Empty, BlackStone, WhiteStone};

extern const int AIPlayer;
extern const int HumanPlayer;

class Sphere {
public:
	Vector3 center;
	float radius;

	Sphere() {}

	float TestRayIntersection(const Ray &ray, bool bounded=false, double magnitude=1.0f) const;
};

struct GoNode {
	int state;
	GoNode *AdjNodes[4];
	Sphere *bvol;
};

extern GoNode GoBoard[19][19];

// returns number of freedoms or -1 if the node passed is empty or a null pointer is passed
int CountStringFreedoms(const GoNode *node);
bool InAtari(const GoNode *node);
void RemoveString(GoNode *node);
float EvaluatePosition(const GoNode *node, int player);
bool IllegalMove(const GoNode *node, int player);
float DistanceFromCenter(const GoNode *node);
int DistanceFromEdge(int dir, const GoNode *node);

bool MakeMove(int *move_x, int *move_y, int sample_count, float threshold, void (*share_time)() = 0);

void CountArea(const GoNode *node, int player);

void foo(int x=1);

#endif	// _GO_H_